<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Key Detection</title>
  <script type="text/javascript" src="https://www.cornify.com/js/cornify.js"></script>
</head>
<body>
<script>
  let period = 500;

  function listen() {
    return new Promise((resolve) => {
      document.addEventListener('keydown', onKeyHandler);
      function onKeyHandler() {
        resolve(1);
      }
      setTimeout(() => {
        clearTimeout();
        resolve(0);
      }, period);
    });
  }

  const secretCode = [1, 0, 1, 1, 1, 1, 0, 0, 1, 1];


  function sleep(milliseconds) {
    const date = Date.now();
    let currentDate = null;
    do {
      currentDate = Date.now();
    } while (currentDate - date < milliseconds);
  }

  const whileLoop = async _ => {
    while (true) {
      let fail = false;
      // Wait for first knock
      while (!await listen()) {
        console.log("idling");
      }
      let userBaseSpace = 0;
      let currentKnockIndex = 0;

      // We determine the user's tempo by looking at how long they take to do the second knock
      while (!await listen()) {
        userBaseSpace++;
      }
      // We can then compare this to the space we expected
      let space = secretCode.indexOf(1, currentKnockIndex) + 1;
      // The user's tempo relative to the secretCode is their userBaseSpace / space
      let userTempo = userBaseSpace / space;
      console.log(`User might be knocking at ${userTempo} times the reference tempo`);

      currentKnockIndex = secretCode.indexOf(1, currentKnockIndex + 1);

      // While there is a next knock in the secret code, or until the knocker makes a mistake
      while (currentKnockIndex < secretCode.length - 1) {
        // Determine expected space given the secretCode and the userTempo
        let expectedSpace = (secretCode.indexOf(1, currentKnockIndex + 1) - currentKnockIndex) * userTempo;
        console.log(`Expected space: ${expectedSpace}`);
        // Mesure knock space
        let currentKnockSpace = 0;
        while (!await listen()) {
          currentKnockSpace++;
        }
        console.log(`Measured knock space ${currentKnockSpace}`);

        // Break the loop if it doesn't match the expected space
        if (currentKnockSpace < expectedSpace - 1 || currentKnockSpace > expectedSpace + 1) {
          fail = true;
          break;
        }
        currentKnockIndex = secretCode.indexOf(1, currentKnockIndex + 1);
      }
      if (fail) {
        console.log("Wrong knock");
        sleep(2000);
      } else {
        cornify_add();
        console.log("Door is opened, congrats");
        sleep(2000);
      }
    }
  };
  whileLoop();
</script>
</body>
</html>
